########################################################################
#
#	NpRandom.pl
#
#	y֐z
#	instance				
#	hdlr_random_source		_\[X^O
#	hdlr_random_source_separator
#							_\[X؂^O
#	hdlr_random_entries		_Gg[^O
#
#	yz
#	Ver	1.00	2010.05.17	vx TY	VK쐬
#
#	Copyright (C) 2010 Shitaro Kubuki. All Rights Reserved
#
package MT::Plugin::NpRandom;

use strict;
use MT;
use MT::Plugin;
use MT::Template::Context;
use base qw( MT::Plugin );
use vars qw($PLUGIN_NAME $VERSION);
$PLUGIN_NAME = 'NAWAGATE plugin Gotchatto Random standard';
$VERSION = '1.00';

my $plugin = MT::Plugin::NpRandom->new({
    id => 'nprandom',
    key => __PACKAGE__,
    name => $PLUGIN_NAME,
    version => $VERSION,
    description => "<__trans phrase='outputs to template at random.'>",
    author_name => "<__trans phrase='Shintaro Kubuki'>",
    author_link => 'http://nawagate.com/',
    doc_link => 'http://appstream.jp/random/index.html',
    l10n_class => 'NpRandom::L10N',
    registry => {
		tags => {
			block => {
				'NpRandom'	=>	\&hdlr_random_source,
				'NpRandomEntries'	=>	\&hdlr_random_entries,
			},
			function => {
				'NpRandomSeparator'	=>	\&hdlr_random_source_separator,
			},
		},
    },
});

MT->add_plugin($plugin);

sub instance { $plugin; }

use vars qw( $SEPARATOR );

$SEPARATOR = '<!-- random source separator -->';

########################################################################
#
#	y֐z
#	hdlr_random_source		_\[X^O
#
#	y@\z
#	ubN^Oň͂\[X_ŏo͂܂B
#	\[X<mt:NpRandomSeparator>ŋ؂܂B
#
#	fBt@CA
#		limit="10"	iȗj
#			o͂錏

#	yz
#	Ver	1.00	2010.07.01	vx TY	VK쐬
#
sub hdlr_random_source {
    my ( $ctx, $args, $cond ) = @_;

	my $limit = $args->{limit} or 0;
	my $builder = $ctx->stash('builder');
	my $tokens  = $ctx->stash('tokens');
	my $out = $builder->build ($ctx, $tokens, $cond);
	return $ctx->error ($builder->errstr) if !defined $out;
	my @list = split(/$SEPARATOR/, $out);
	@list = sort { int(rand(3)) - 1 } @list;
	if ( $limit == 0 )
	{
		$limit = $#list + 1;
	}
	if ( $#list + 1 < $limit )
	{
		$limit = $#list + 1;
	}
	my $buffer = "";
	for ( my $index = 0; $index < $limit; $index++ )
	{
		$buffer .= $list[$index];
	}
	$out = $buffer;
	return $out;

}
########################################################################
#
#	y֐z
#	hdlr_random_source_separator
#							_\[X؂^O
#
#	y@\z
#	
#
#	yz
#	Ver	1.00	2010.07.01	vx TY	VK쐬
#
sub hdlr_random_source_separator {
	my ( $ctx, $args, $cond ) = @_;

	return $SEPARATOR;

}
########################################################################
#
#	y֐z
#	hdlr_random_entries		_Gg[^O
#
#	y@\z
#	<mt:Entries>_ŏo͂܂B
#	ӁjfBt@CAw肵Ȃꍇ
#	@@@@EJeS̃Jg̓[g
#	@@@@Eo͂uOĽ͑S
#	@@@ƂȂ܂B
#	@@@S_ɕѕς邽߃uOĽꍇAԂ|܂B
#
#	yz
#	Ver	1.00	2010.07.01	vx TY	VK쐬
#
sub hdlr_random_entries {
    my ( $ctx, $args, $cond ) = @_;

	my $blog = $ctx->stash('blog');
	my $blog_id = $blog->id;
	my @entries = MT::Entry->load({ blog_id => $blog_id, status => 2 });
	@entries = sort { int(rand(3)) - 1 } @entries;
	local $ctx->{__stash}{entries} = \@entries;
	my $res = "";
	if (MT->version_number < 5)
	{
		$res = $ctx->_hdlr_entries($args, $cond);
	}
	else
	{
		$res = $ctx->invoke_handler('entries', $args, $cond);
	}

	return $res;

}
	1;
